//4Get - cjc - 12/06/2013
//Read mM data on UART RXD.
//Buffer the data, format, and store in MySQL Database (push model).
//Adapted from: Rabbit/3Get
//Adapt Rabbit 3720 code to Raspberry Pi
//The Rabbit version assembled a "ct.dat" file of unformatted, un-dated mM outout that filled in
//a http request for 3cap.php on the Yahoo server that created the formatted entry for a MySQL database.
//Identification data was embedded in the source code.
//This version will complete the formatting here and obtain a date stamp from a server.
//update limit set at main()
/*
Timing Facts:

8640 channel readings per 24 hours
540 sets-of-16 as a line in mm.db1 per day (8640/16)
22.5 sets (lines in mm.db1) per hour (540/24)
45 lines in mm.db1 per 2-hours (120 minutes)
9 lines in mm.db1 per 24-minute interval
3 lines in mm.db1 per 8-minute interval
1 line in mm.db1 represents 2.667 minutes

prep RP for serial comm:
 /etc/inittab    # b4 last line
 /boot/cmdline.txt    delete console=ttyAMA0,115200 kgdboc=ttyAMA0,115200 
*/

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h> //Used for UART
#include <fcntl.h> //Used for UART
#include <termios.h> //Used for UART
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#define PORT 		80
#define DS1 0		//GPIO 17
#define DS2 1		//GPIO 18

// these are global variables
char ch2[50];char crlf[5];char temp1[9];char temp2[50];
char e1[9];char e2[9];char e3[9];char e4[9];char e5[9];char e6[9];char e7[9];char e8[9];
char str1[5];char str2[1];char str3[1];char str4[50];char str5[50];
char str6[200];char str7[200];char str8[200];char str9[200];
char str10[800];
char sg01[50];char sg02[50];char sg03[50];char sg04[50];
char sg05[50];char sg06[50];char sg07[50];char sg08[50];
char sg09[50];char sg10[50];char sg11[50];char sg12[50];
char sg13[50];char sg14[50];char sg15[50];char sg16[50];           
int h;int sw1;int sw2;int sw3;int sw4;int sw5;int sw6;
int cnt1;int cnt2;int cnt3;
int s6;int s7;int s8;int s9;
int len1=0; int i=0; int j=0; int k=0;
int cm1=0; int cm2=0;  int cm3=0; int cm4=0;  
int cm5=0; int cm6=0;  int cm7=0; int g=0; int f2 ;int f3 ;
char date1[100];char procID1[10];

//....+....1....+....2....+....3....+....4....+....5....+....6....+....7....+....8
//mM0120020909131542,01,010,38979,00028,010,38979,00028,10000, 15 more 41-byte groups for mMII = 674 bytes*

int configure_port(int fd)      // configure the port
{
    struct termios options;
    tcgetattr(fd, &options);
    cfsetispeed(&options, B300);
    cfsetospeed(&options, B300);
    tcsetattr(fd, TCSANOW, &options);
    return(fd);
} //configure_port 

void get1(){
   char b1[1000];
   char buffer[1000 + 1]; /* +1 so we can add null terminator */
   int len, mysocket,len2;
   struct sockaddr_in dest; 
   mysocket = socket(AF_INET, SOCK_STREAM, 0);
   memset(&dest, 0, sizeof(dest));                /* zero the struct */
   dest.sin_family = AF_INET;
   dest.sin_addr.s_addr = inet_addr("98.139.135.199 "); /* set destination IP number */ 
   dest.sin_port = htons(80);                /* set destination port number */
   connect(mysocket, (struct sockaddr *)&dest, sizeof(struct sockaddr));
 //send get req here
   strcpy(b1,"GET /hitc/r2/4Get.php?userID="); //directory
   strcat(b1,"chriscle");//userID
   strcat(b1,"&procID=");
   strcat(b1,"s612");    //procID - 4 chars    change IP too   s=3->16  n=15
   strcat(b1,"&ctdat="); //                                
   strcat(b1,str10);
   strcat(b1," HTTP/1.1\r\nHost: www.yourYahooSmallBusiness.com\r\n\r\n");
   len=strlen(b1);
   printf("\nSending %s (%d bytes).\n", b1, len);
   len2 = send(mysocket, b1, len, 0);
   len = recv(mysocket, buffer, 500, 0);
   /* We have to null terminate the received data ourselves */
   buffer[len] = '\0';
   printf("\nReceived %s (%d bytes).\n", buffer, len);
   close(mysocket);
   return EXIT_SUCCESS;

}//get1

void format1() 
//This formats segments in str5 from 3,9,24977,52,9,24359,52,10603  to
//                                   03,000,04586,00036,000,30560,00036,10602
{
 strcpy(str5,str4);
 len1=strlen(str4); i=0; j=0;
 cm1=0; cm2=0; cm3=0; cm4=0; cm5=0; cm6=0; cm7=0; 
 strcpy(str2,",");//102
//final commas are at 3 7 13 19 23 29 35    len 40
 for (i = 0; i < len1; i++)
 {
  j=i+1; 
//107
 strncpy(str3, str4+i, 1); 
  if (strcmp(str2,str3) == 0 && cm7 == 0 && cm1 > 0 && cm2 > 0 && cm3 > 0 && cm4 > 0 && cm5 > 0 && cm6 > 0){cm7=j;}
  if (strcmp(str2,str3) == 0 && cm6 == 0 && cm1 > 0 && cm2 > 0 && cm3 > 0 && cm4 > 0 && cm5 > 0){cm6=j;}
  if (strcmp(str2,str3) == 0 && cm5 == 0 && cm1 > 0 && cm2 > 0 && cm3 > 0 && cm4 > 0){cm5=j;}
  if (strcmp(str2,str3) == 0 && cm4 == 0 && cm1 > 0 && cm2 > 0 && cm3 > 0){cm4=j;}
  if (strcmp(str2,str3) == 0 && cm3 == 0 && cm1 > 0 && cm2 > 0){cm3=j;}
  if (strcmp(str2,str3) == 0 && cm2 == 0 && cm1 > 0){cm2=j;}
  if (strcmp(str2,str3) == 0 && cm1 == 0 ){cm1=j;}


 }
//prepend 0
strcpy(temp1,"");strcpy(e1,"");
strncpy(e1,str4,cm1-1); e1[cm1-1] = '\0';//FIXX!!!   cm1-2 is destination size
if (strlen(e1)<2){strcpy(temp1,"0");strcat(temp1,e1);strcpy(e1,temp1);} 
  
strcpy(temp1,"");strcpy(e2,"");
strncpy(e2,str4+cm1,cm2-cm1-1); e2[cm2-cm1-1] = '\0';
if (strlen(e2)<3){strcpy(temp1,"0");strcat(temp1,e2);strcpy(e2,temp1);} 
if (strlen(e2)<3){strcpy(temp1,"0");strcat(temp1,e2);strcpy(e2,temp1);} 

strcpy(temp1,"");strcpy(e3,"");
strncpy(e3,str4+cm2,cm3-cm2-1); e3[cm3-cm2-1] = '\0';
if (strlen(e3)<5){strcpy(temp1,"0");strcat(temp1,e3);strcpy(e3,temp1);} 
if (strlen(e3)<5){strcpy(temp1,"0");strcat(temp1,e3);strcpy(e3,temp1);} 
if (strlen(e3)<5){strcpy(temp1,"0");strcat(temp1,e3);strcpy(e3,temp1);} 
if (strlen(e3)<5){strcpy(temp1,"0");strcat(temp1,e3);strcpy(e3,temp1);} 

strcpy(temp1,"");strcpy(e4,"");
strncpy(e4,str4+cm3,cm4-cm3-1); e4[cm4-cm3-1] = '\0';
if (strlen(e4)<5){strcpy(temp1,"0");strcat(temp1,e4);strcpy(e4,temp1);} 
if (strlen(e4)<5){strcpy(temp1,"0");strcat(temp1,e4);strcpy(e4,temp1);} 
if (strlen(e4)<5){strcpy(temp1,"0");strcat(temp1,e4);strcpy(e4,temp1);} 
if (strlen(e4)<5){strcpy(temp1,"0");strcat(temp1,e4);strcpy(e4,temp1);} 

strcpy(temp1,"");strcpy(e5,"");
strncpy(e5,str4+cm4,cm5-cm4-1); e5[cm5-cm4-1] = '\0';
if (strlen(e5)<3){strcpy(temp1,"0");strcat(temp1,e5);strcpy(e5,temp1);} 
if (strlen(e5)<3){strcpy(temp1,"0");strcat(temp1,e5);strcpy(e5,temp1);} 

strcpy(temp1,"");strcpy(e6,"");
strncpy(e6,str4+cm5,cm6-cm5-1); e6[cm6-cm5-1] = '\0';
if (strlen(e6)<5){strcpy(temp1,"0");strcat(temp1,e6);strcpy(e6,temp1);} 
if (strlen(e6)<5){strcpy(temp1,"0");strcat(temp1,e6);strcpy(e6,temp1);} 
if (strlen(e6)<5){strcpy(temp1,"0");strcat(temp1,e6);strcpy(e6,temp1);} 
if (strlen(e6)<5){strcpy(temp1,"0");strcat(temp1,e6);strcpy(e6,temp1);} 

strcpy(temp1,"");strcpy(e7,"");
strncpy(e7,str4+cm6,cm7-cm6-1); e7[cm7-cm6-1] = '\0';
if (strlen(e7)<5){strcpy(temp1,"0");strcat(temp1,e7);strcpy(e7,temp1);} 
if (strlen(e7)<5){strcpy(temp1,"0");strcat(temp1,e7);strcpy(e7,temp1);} 
if (strlen(e7)<5){strcpy(temp1,"0");strcat(temp1,e7);strcpy(e7,temp1);} 
if (strlen(e7)<5){strcpy(temp1,"0");strcat(temp1,e7);strcpy(e7,temp1);} 

strcpy(temp1,"");strcpy(e8,"");
strncpy(e8,str4+cm7,len1-cm7-1); e3[len1-cm7-1] = '\0';
if (strlen(e3)<5){printf("ID ERROR e8 %s \n",e8);} 

strcpy(str5,"");
strcat(str5,e1);
strcat(str5,",");
strcat(str5,e2);
strcat(str5,",");
strcat(str5,e3);
strcat(str5,",");
strcat(str5,e4);
strcat(str5,",");
strcat(str5,e5);
strcat(str5,",");
strcat(str5,e6);
strcat(str5,",");
strcat(str5,e7);
strcat(str5,",");
strcat(str5,e8);
strcat(str5,",");

//printf("str5 %s \n",str5);

}


void build1()
{
                g=atoi(e1);
                printf("%s",str4);//we have the whole line here
                h+=1;
                if (h>16) {h=1;sw1=1;}//1-16
                
//At this point we have unformatted segments in str5 that can be handled with format1().

                //printf("h=%d, g=%d \n",h,g);

                if (h==1) {

                 strcpy(str6,"");
                 strcpy(str7,"");
                 strcpy(str8,"");
                 strcpy(str9,"");
                 strcpy(str10,"");
                 sw2=0;
                          }//clear long buffers

              //  strcpy(str4,"");
              //Not necessarily starting w channel 1, just hold 16

//                       usleep(500 * 1000);
if (g==1){write(f2, "1", 1);}//Turn 1st led on
if (g==5){write(f3, "1", 1);}//Turn 2nd led on
if (g==9){write(f2, "0", 1);}//Turn 1st led off
if (g==9){write(f3, "0", 1);}//Turn 2nd led off

              if (g==1){strcpy(sg01,str5);}
              if (g==2){strcpy(sg02,str5);}
              if (g==3){strcpy(sg03,str5);}
              if (g==4){strcpy(sg04,str5);}
              if (g==5){strcpy(sg05,str5);}
              if (g==6){strcpy(sg06,str5);}
              if (g==7){strcpy(sg07,str5);}
              if (g==8){strcpy(sg08,str5);}
              if (g==9){strcpy(sg09,str5);}
              if (g==10){strcpy(sg10,str5);}
              if (g==11){strcpy(sg11,str5);}
              if (g==12){strcpy(sg12,str5);}
              if (g==13){strcpy(sg13,str5);}
              if (g==14){strcpy(sg14,str5);}
              if (g==15){strcpy(sg15,str5);}
              if (g==16){strcpy(sg16,str5);}//g puts them in order, h just counts

              if (h==15){sw2=1;}//cock the switch
              if (h==16 && sw2==1){
               sw2=0;
               strcat(str6,sg01);strcat(str6,crlf);
               strcat(str6,sg02);strcat(str6,crlf);
               strcat(str6,sg03);strcat(str6,crlf);
               strcat(str6,sg04);strcat(str6,crlf);s6=strlen(str6);
               strcat(str7,sg05);strcat(str7,crlf);
               strcat(str7,sg06);strcat(str7,crlf);
               strcat(str7,sg07);strcat(str7,crlf);
               strcat(str7,sg08);strcat(str7,crlf);s7=strlen(str7);
               strcat(str8,sg09);strcat(str8,crlf);
               strcat(str8,sg10);strcat(str8,crlf);
               strcat(str8,sg11);strcat(str8,crlf);
               strcat(str8,sg12);strcat(str8,crlf);s8=strlen(str8);
               strcat(str9,sg13);strcat(str9,crlf);
               strcat(str9,sg14);strcat(str9,crlf);
               strcat(str9,sg15);strcat(str9,crlf);
               strcat(str9,sg16);strcat(str9,crlf);s9=strlen(str9);
               strcat(str10,str6);
               strcat(str10,str7);
               strcat(str10,str8);
               strcat(str10,str9);strcat(str10,crlf);//email this

               printf(" Final  %s End Final \n ",str10);

               cnt1++;sw5=1;cnt3++;//200
               if (cnt1 > cnt2) 
               {
                  get1();
                  cnt1=0;
               }// limit updates
              }//h16 sw2
              if (sw6 > 0 && cnt3 > 1000) {cnt2 = 22;}
}//build1


//main()
int main(int argc,char *argv[])
{
   printf("hello 0 \n\r");
//    scanf("%u", &port);//read sysin
        if (argc != 2) {
            printf("Usage: %s procID\n",argv[0]);
            return 1;
        }
        strcpy(procID1,argv[1]);
        printf("%s received procID=%s\n",argv[0],procID1);

//strcpy(procID1,"mM01");
time_t now = time(NULL);
struct tm *t = localtime(&now);
strftime(date1, sizeof(date1)-1, "%Y%m%d%H%M%S", t);
printf("%s%s", procID1,date1);
//mM0120131220135447

      int fd ;char buf[256];int n=0;

      f2 = open("/sys/class/gpio/export", O_WRONLY);write(f2, "17", 2);close(f2);
      f2 = open("/sys/class/gpio/gpio17/direction", O_WRONLY);write(f2,"out",3);close(f2);
      f2 = open("/sys/class/gpio/gpio17/value", O_WRONLY);write(f2, "0", 1);

      f3 = open("/sys/class/gpio/export", O_WRONLY);write(f3, "18", 2);close(f3);
      f3 = open("/sys/class/gpio/gpio18/direction", O_WRONLY);write(f3,"out",3);close(f3);
      f3 = open("/sys/class/gpio/gpio18/value", O_WRONLY);write(f3, "0", 1);

      fd = open("/dev/ttyAMA0", O_RDONLY | O_NOCTTY | O_NDELAY);

      if (fd == -1) {
        perror("open_port: Unable to open mM on  /dev/ttyAMA0 - ");
        return(-1);
      }
         
      n=configure_port(fd);

      // Turn off blocking for reads, use (fd, F_SETFL, FNDELAY) if you want that
      fcntl(fd, F_SETFL, 0);
	 
   cnt1 = 20;//226
   cnt2 = 0;
   cnt3 = 0;//never resets, with sw6=1 reduces updates later
   sw6 = 1;// 1 for limiting later
   //cnt2 = 22; //limit updates  cnt2 = 0 skips none, 22 2-hours
   //cnt1 = 20; //quick start
//....+....1....+....2....+....3....+....4....+....5....+....6....+....7....+....8
   printf("\n4Get v1.21 for Raspberry Pi\n\r");
   sw4=0;
   //strcpy(crlf,"crlf");
   strcpy(crlf,"");
   //"\n\r");
   h=0;sw1=0;sw5=0;
   strcpy(str4,"");//clear buffer  
 
   //get1();//immediately test connection once without data


while (1)
   {
//This happens for every byte from Mm. Add logic to build, print, and clear a string for each channel.
//                       line
//READ --------------------------------------------------
                 
      // Read up to 255 characters from the port if they are there
//      n = read(fd, (void*)buf, 255);   
      n = read(fd, &buf, 255);// we get a whole line at a time

      if (n < 0) {
        perror("Read failed - ");
        return -1;
      } else if (n == 0) printf("No mM data on port\n");
      else {
        buf[n] = '\0';                //379

        if(n>1)
          {
            strcpy(str4,buf);
            format1();
            build1();
          }
      }//else

}//while (1)

     close(fd);

}



